
nEnemy                  equ 20                  ; Number of them

; The offsets into an enemy spaceship

        struct
dX                      ds 1                    ; 0
dXH                     ds 1                    ; 1
dY                      ds 1                    ; 2
dYH                     ds 1                    ; 3
dSpritePtr              ds 1                    ; 4
dSpritePtrH             ds 1                    ; 5
dMoveShipCode           ds 2                    ; 6/7
dShapeAndAlive          ds 1                    ; 8
dFractX                 ds 1                    ; 9   Very speculative name
dFractY                 ds 1                    ; 10  Very speculative name
dAngle                  ds 1                    ; 11
dAngle2                 ds 1                    ; 12
dScaledX                ds 1                    ; 13
dScaledY                ds 1                    ; 14
lEnemy                  equ *
        send

; A useful macro

mNegHL                  macro()
                          LD   A,H
                          CPL
                          LD   H,A
                          LD   A,L
                          CPL
                          LD   L,A
                          INC  HL
                          mend

; Init the enemy

InNME                   LD   IX,tNME                            ;
                        LD   B,nEnemy                           ;

InNME0                  PUSH BC

                        call RandOnly_A                         ; Random X
                        LD   (IX+dX),A                          ; Should be signed really
                        LD   (IX+dXH),0                         ;

                        call RandOnly_A                         ; Random Y
                        LD   (IX+dY),A                          ; In front-ish
                        LD   (IX+dYH),-2                        ;

                        LD   (IX+dSpritePtr),0                  ; Shape? Ignored?
                        LD   (IX+dSpritePtrH),high EnemyShip    ;

                        LD   HL,SimpleShipMove                  ;
                        LD   (IX+dMoveShipCode),HL              ;

                        LD   (IX+dShapeAndAlive),high EnemyShip ; Set the ship-shape set
                        LD   (IX+dFractX),0                     ;
                        LD   (IX+dFractY),0                     ;
                        call RandOnly_A                         ; Random X
                        AND  #1F                                ;
                        LD   (IX+dAngle),A                      ;
                        LD   (IX+dAngle2),100                   ;

                        CALL SRScan                             ;
                        CALL LRScan                             ;
                        CALL SRSBit                             ;
                        CALL DrawSprite                         ;

                        POP  BC                                 ;
                        LD   DE,lEnemy                          ;
                        ADD  IX,DE                              ;

                        DJNZ InNME0                             ;
                        RET                                     ;

; Move them all

MvNME                   LD   IX,tNME

                        CALL LRSClr

                        LD   B,nEnemy

                        XOR  A
                        LD   (condition),A

MoveEnemyLp             PUSH BC

                        LD   A,(IX+dShapeAndAlive)
                        OR   A
                        JP   Z,MoveEnemyNext

                        PUSH IX

                        ; Copy the sprite drawing code into the buffer

                        LD DE,IX
                        ld hl,tInDef

                        loop 6
                          ld a,(de)
                          inc de
                          ld (hl),a
                          inc l
                          lend

                        ; Now we have the code to move/rotate the ship... frightening stuff.

                        LD   A,(IX+dX)
                        RLCA
                        AND  1
                        ADC  A,(IX+dXH)
                        JR   NZ,MvN2

                        LD   A,(IX+dY)
                        RLCA
                        AND  1
                        ADC  A,(IX+dYH)
                        JR   Z,MvN3

MvN2                    LD   DE,(IX+dY)
                        LD   A,(angle)
                        ld c,0
                        CALL RotMS
                        LD   DE,(IX+dX)

                        LD   A,(angsig)
                        RRA
                        JR   C,MvN2a

                        ADD  HL,DE
                        JR   MvN2b

MvN2a                   EX   DE,HL
                        OR   A
                        SBC  HL,DE

MvN2b                   LD   (IX+dX),HL
                        EX   DE,HL
                        LD   A,(angle)
                        CALL RotMS
                        LD   DE,(IX+dY)

                        LD   A,(angsig)
                        RRA
                        JR   NC,MvN2c

                        ADD  HL,DE
                        JR   MvN2d

MvN2c                   EX   DE,HL
                        SBC  HL,DE

MvN2d                   LD   DE,(fwdmov)
                        LD   A,(IX+dFractY)
                        LD   C,D
                        RL   D
                        LD   B,0
                        JR   NC,MvN2e
                        LD   B,#FF
MvN2e                   ADD  A,E
                        ADC  HL,BC
                        LD   (IX+dFractY),A
                        LD   (IX+dY),HL
                        JP   MvN4

                        ; I think this means it's visible? Hmmm. not convinced.

MvN3                    LD   E,(IX+dFractY)
                        LD   D,(IX+dY)
                        LD   A,(angle)
                        CALL RotMS
                        LD   E,(IX+dFractX)
                        LD   D,(IX+dX)

                        LD   A,(angsig)
                        RRA
                        JR   C,MvN3a
                        ADC  HL,DE
                        LD   A,H
                        JP   NV,MvN3b
                        CPL
                        JP   MvN3b
MvN3a                   EX   DE,HL
                        OR   A
                        SBC  HL,DE
                        LD   A,H
                        JP   NV,MvN3b

                        CPL

MvN3b                   ADD  A,A
                        SBC  A,A
                        LD   (IX+dXH),A
                        LD   (IX+dFractX),L
                        LD   (IX+dX),H
                        EX   DE,HL
                        XOR  D
                        EX   AF,AF'
                        LD   A,(angle)
                        CALL RotMS
                        EX   AF,AF'
                        RLA
                        JR   NC,MvN3ba
                        mNegHL()
MvN3ba                  LD   E,(IX+dFractY)
                        LD   D,(IX+dY)
                        LD   A,(angsig)
                        RRA
                        JR   NC,MvN3c
                        XOR   A
                        ADC  HL,DE
                        JP   NV,MvN3d
                        CPL
                        JP   MvN3d
MvN3c                   EX   DE,HL
                        SBC  HL,DE
                        LD   A,0
                        JP   NV,MvN3d
                        CPL
MvN3d                   LD   DE,(fwdmov)
                        OR   A
                        ADC  HL,DE
                        LD   (IX+dFractY),L
                        LD   (IX+dY),H
                        JP   NV,MvN3e
                        CPL
MvN3e                   XOR  H
                        ADD  A,A
                        SBC  A,A
                        LD   (IX+dYH),A
MvN4                    LD   A,(angle)
                        LD   C,A
                        LD   A,(angsig)
                        RRA
                        LD   A,(IX+dAngle2)
                        JR   C,MvN7
                        SUB  C
                        LD   (IX+dAngle2),A
                        JR   NC,MvN9
                        LD   C,A
                        LD   A,(IX+dAngle)
                        DEC  A
                        AND  #1F
                        LD   (IX+dAngle),A
                        LD   A,nRotat
                        ADD  A,C
                        JP   MvN8

MvN7                    ADD  A,C
                        CP   nRotat
                        LD   (IX+dAngle2),A
                        JR   C,MvN9

                        LD   C,A
                        LD   A,(IX+dAngle)
                        INC  A
                        AND  #1F
                        LD   (IX+dAngle),A

                        LD   A,C
                        SUB  nRotat

MvN8                    LD   (IX+dAngle2),A

                        LD   L,(IX+dAngle)                  ; Angle?
                        LD   H,0
                        LD   E,H                        ;
                        LD   D,(IX+dShapeAndAlive)      ; DE := base of ship shapes

                        ADD  HL,HL                      ; * sprite length
                        ADD  HL,HL                      ;
                        ADD  HL,HL                      ;
                        ADD  HL,HL                      ;
                        ADD  HL,HL                      ;
                        ADD  HL,DE                      ; And add base

                        LD   (IX+4),HL                  ; Ship sprite

MvN9                    NOP

                        LD   HL,MoveEnemyUpdateScreen   ; Come back to here

                        PUSH HL                         ; Move the ship
                        LD   HL,(IX+dMoveShipCode)      ;
                        JP   (HL)                       ;

                ; It has changed, so draw and undraw the damned thing

MoveEnemyDrawIt         PUSH IX                         ; Save
                        CALL DrawSprite                 ; Draw the ship's new position

                        LD   IX,tInDef                  ; Undraw the old position
                        CALL DrawSprite                 ;

                        POP  IX                         ; Restore
                        JP   MoveEnemyDrawn             ;

                ; See if anything has changed about this ship

MoveEnemyUpdateScreen   POP  DE                         ; Restore
                        LD IX,DE                        ;

                        ; Has anything about the drawn sprite changed?

                        LD HL,tInDef                    ; Compare it with the copy we saved in the buffer

                        loop 6
                          LD   A,(DE)                   ;
                          CP   (HL)                     ;
                          JR   NZ,MoveEnemyDrawIt       ;
                          INC  DE                       ;
                          INC  L                        ;
                          lend                          ;

                        ; If we get here nothing changed

MoveEnemyDrawn          LD   A,(shstat)
                        OR   A
                        JR   Z,MvNME6                   ;

                        CALL LRScan                     ;
                        CALL SRScan                     ;
                        JR   NC,MvNMEa                  ;

                        LD   HL,condition               ; Set bit 0 of condition
                        SET  0,(HL)                     ;

                        JR   MvNMEa

MvNME6                  CALL LRScan
                        CALL SRSBit
                        CALL SRScan
                        JR   NC,MvNMEa

                        LD   HL,condition
                        SET  0,(HL)
                        CALL SRSBit

MvNMEa                  CALL ConRed                     ; Returns CF set if visible on screen
                        JR   NC,MoveEnemyNext           ; Not visible...

                        LD   HL,condition               ; Set the shield flag
                        SET  1,(HL)                     ;

MoveEnemyNext           POP  BC                         ; Move enemy loop

                        LD   DE,lEnemy                  ;
                        ADD  IX,DE                      ;

                        DEC  B                          ;
                        JP   NZ,MoveEnemyLp             ;

                        ; Drive the shield status

                        LD   A,(shstat)
                        OR   A
                        CALL Z,LRSCpy

                        ; Drive one of the indicator lights depending on enemy visible

                        LD   A,(condition)
                        CP   1
                        JR   NC,MvNME8

                        LD   A,Lmp5a
                        LD   (Lamp5),A
                        RET

MvNME8                  JR   NZ,MvNME9

                        LD   A,Lmp5b
                        LD   (Lamp5),A
                        RET

MvNME9                  LD   A,Lmp5c
                        LD   (Lamp5),A
                        RET

; Code to move the ship?

SimpleShipMove          ld a,(ix+dX)
                        inc a
;                        and #1F
                        ld (ix+dX),a
                        ret

; Check if this ship is on the screen...

ConRed                  LD   A,(IX+dXH)         ;  0 <= X <= $100
                        OR   A
                        JR   Z,ConR1

                        CPL
                        OR   A
                        RET  NZ

                        LD   A,(IX+dX)
                        CPL
                        CP   98
                        JP   C,ConR2
                        RET

                ; X = 0..255

ConR1                   LD   A,(IX+dX)
                        CP   96
                        RET  NC

                ; X < 96

ConR2                   LD   A,(IX+dYH)
                        OR   A
                        JR   Z,ConR3

                        CPL
                        OR   A
                        RET  NZ

                        LD   A,(IX+dY)
                        CPL
                        CP   98
                        RET

ConR3                   LD   A,(IX+dY)
                        CP   96
                        RET


