; The line-drawing code

; A common end routine
mLineEnd                macro(loopaddr)
                          EXX
                          LD   A,L
                          EX   AF,AF'
                          DJNZ loopaddr
                          ; A copy of LnF
                          EX   AF,AF'
                          EXX
                          OR  (HL)
                          LD   (HL),A
                          RET
                          mend

; Draw a line, HL = X,Y DE = X1,Y1, and C = attribute

Line                    LD   A,L
                        CP   E
                        JR   NC,Lne0

                        EX   DE,HL

Lne0                    PUSH HL
                        PUSH DE

                        LD   A,D
                        RRA
                        RRA
                        RRA
                        AND  #1F

                        LD   H,high ScreenTable
                        LD   L,E

                        ADD  A,(HL)
                        INC  H
                        LD   H,(HL)
                        LD   E,A
                        LD   A,L
                        LD   L,E

                        RLCA
                        RLCA
                        AND  3

                        ADD  A,#58

                        LD   D,A
                        LD   A,C
                        LD   (DE),A

                        EXX

                        POP  DE

                        LD   A,D
                        AND  7
                        LD   L,A
                        LD   H,high Bits
                        LD   A,(HL)
                        EX   AF,AF'

                        LD   A,E
                        CPL
                        AND  7
                        INC  A
                        LD   C,A

                        POP  HL

                        LD   A,L
                        SUB  E
                        LD   E,A

                        LD   A,H
                        SUB  D
                        JP   C,Lnl

                        CP   E
                        JP   C,Lnry

                        LD   B,A
                        SUB  E
                        LD   D,A

                        EX   AF,AF'
                        LD   L,A
                        EX   AF,AF'

                        LD   A,B
                        SRL  A
                        SUB  E
Lnrx1                   JR   C,Lnrx5

Lnrx2                   SUB  E
                        EX   AF,AF'
                        RRC  L
                        JR   C,Lnrx3

                        OR   L
                        EX   AF,AF'
                        DJNZ Lnrx1

                        EX   AF,AF'
                        EXX
                        OR  (HL)
                        LD   (HL),A
                        RET

Lnrx3                   EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  L
                        INC  E
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnrx1)

Lnrx4                   JR   C,Lnrx2

Lnrx5                   ADD  A,D
                        EX   AF,AF'
                        DEC  C
                        JR   Z,Lnrx7

                        RRC  L
                        JR   C,Lnrx6

                        EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  H

                        mLineEnd(Lnrx4)

Lnrx6                   EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  H
                        INC  L
                        INC  E
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnrx4)

Lnrx7                   LD   C,8
                        RRC  L
                        JR   C,Lnrx9

                        EXX
                        OR  (HL)
                        LD   (HL),A
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        LD   E,A
                        JR   C,Lnrx8

                        LD   A,H
                        SUB  7
                        LD   H,A
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnrx4)

Lnrx8                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnrx4)

Lnrx9                   EXX
                        OR  (HL)
                        LD   (HL),A
                        LD   A,L
                        ADD  A,33
                        LD   L,A
                        LD   E,A
                        JR   C,LnrxA
                        LD   A,H
                        SUB  7
                        LD   H,A
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnrx4)

LnrxA                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnrx4)

Lnry                    LD   D,A
                        LD   A,E
                        LD   B,E
                        SUB  D
                        LD   E,A
                        EX   AF,AF'
                        LD   L,A
                        EX   AF,AF'
                        LD   A,B
                        SRL  A
                        SUB  D
Lnry0                   JR   C,Lnry5

Lnry1                   SUB  D
                        EX   AF,AF'
                        DEC  C
                        JR   Z,Lnry2

                        EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  H

                        mLineEnd(Lnry0)

Lnry2                   LD   C,8
                        EXX
                        OR  (HL)
                        LD   (HL),A
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        LD   E,A
                        JR   C,Lnry3
                        LD   A,H
                        SUB  7
                        LD   H,A
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnry0)

Lnry3                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnry0)

Lnry4                   JR   C,Lnry1

Lnry5                   ADD  A,E
                        EX   AF,AF'
                        DEC  C
                        JR   Z,Lnry7

                        RRC  L
                        JR   C,Lnry6

                        EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  H

                        mLineEnd(Lnry4)

Lnry6                   EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  H
                        INC  L
                        INC  E
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnry4)

Lnry7                   LD   C,8
                        RRC  L
                        JR   C,Lnry9

                        EXX
                        OR  (HL)
                        LD   (HL),A
                        LD   A,L
                        ADD  A,32
                        LD   L,A
                        LD   E,A
                        JR   C,Lnry8

                        LD   A,H
                        SUB  7
                        LD   H,A
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnry4)

Lnry8                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnry4)

Lnry9                   EXX
                        OR  (HL)
                        LD   (HL),A
                        LD   A,L
                        ADD  A,33
                        LD   L,A
                        LD   E,A
                        JR   C,LnryA

                        LD   A,H
                        SUB  7
                        LD   H,A
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnry4)

LnryA                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnry4)

Lnl                     NEG
                        CP   E
                        JP   C,Lnly

                        LD   B,A
                        SUB  E
                        LD   D,A

                        EX   AF,AF'
                        LD   L,A
                        EX   AF,AF'

                        LD   A,B
                        SRL  A
                        SUB  E
Lnlx1                   JR   C,Lnlx5

Lnlx2                   SUB  E
                        EX   AF,AF'
                        RLC  L
                        JR   C,Lnlx3

                        OR   L
                        EX   AF,AF'
                        DJNZ Lnlx1

                        EX   AF,AF'
                        EXX
                        OR  (HL)
                        LD   (HL),A
                        RET

Lnlx3                   EXX
                        OR  (HL)
                        LD   (HL),A
                        DEC  L
                        DEC  E
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnlx1)

Lnlx4                   JR   C,Lnlx2

Lnlx5                   ADD  A,D
                        EX   AF,AF'
                        DEC  C
                        JR   Z,Lnlx7

                        RLC  L
                        JR   C,Lnlx6

                        EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  H

                        mLineEnd(Lnlx4)

Lnlx6                   EXX
                        OR  (HL)
                        LD   (HL),A
                        INC  H
                        DEC  L
                        DEC  E
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnlx4)

Lnlx7                   LD   C,8
                        RLC  L
                        JR   C,Lnlx9

                        EXX
                        OR   (HL)
                        LD   (HL),A

                        LD   A,L
                        ADD  A,32
                        LD   L,A

                        LD   E,A
                        JR   C,Lnlx8

                        LD   A,H
                        SUB  7
                        LD   H,A

                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnlx4)

Lnlx8                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnlx4)

Lnlx9                   EXX
                        OR   (HL)
                        LD   (HL),A

                        LD   A,L
                        ADD  A,31
                        LD   L,A

                        LD   E,A
                        JR   C,LnlxA

                        LD   A,H
                        SUB  7
                        LD   H,A

                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnlx4)

LnlxA                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnlx4)

Lnly                    LD   D,A
                        LD   A,E
                        LD   B,E
                        SUB  D
                        LD   E,A
                        EX   AF,AF'
                        LD   L,A
                        EX   AF,AF'
                        LD   A,B
                        SRL  A
                        SUB  D
Lnly0                   JR   C,Lnly5

Lnly1                   SUB  D
                        EX   AF,AF'
                        DEC  C
                        JR   Z,Lnly2

                        EXX
                        OR   (HL)
                        LD   (HL),A
                        INC  H

                        mLineEnd(Lnly0)

Lnly2                   LD   C,8
                        EXX
                        OR   (HL)
                        LD   (HL),A

                        LD   A,L
                        ADD  A,32
                        LD   L,A

                        LD   E,A
                        JR   C,Lnly3

                        LD   A,H
                        SUB  7
                        LD   H,A

                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnly0)

Lnly3                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnly0)

Lnly4                   JR   C,Lnly1

Lnly5                   ADD  A,E
                        EX   AF,AF'
                        DEC  C
                        JR   Z,Lnly7

                        RLC  L
                        JR   C,Lnly6

                        EXX
                        OR   (HL)
                        LD   (HL),A
                        INC  H

                        mLineEnd(Lnly4)

Lnly6                   EXX
                        OR   (HL)
                        LD   (HL),A
                        INC  H
                        DEC  L
                        DEC  E
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnly4)

Lnly7                   LD   C,8
                        RLC  L
                        JR   C,Lnly9

                        EXX
                        OR   (HL)
                        LD   (HL),A

                        LD   A,L
                        ADD  A,32
                        LD   L,A

                        LD   E,A
                        JR   C,Lnly8

                        LD   A,H
                        SUB  7
                        LD   H,A

                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnly4)

Lnly8                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnly4)

Lnly9                   EXX
                        OR   (HL)
                        LD   (HL),A

                        LD   A,L
                        ADD  A,31
                        LD   L,A

                        LD   E,A
                        JR   C,LnlyA

                        LD   A,H
                        SUB  7
                        LD   H,A

                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnly4)

LnlyA                   INC  H
                        INC  D
                        LD   A,C
                        LD   (DE),A

                        mLineEnd(Lnly4)

